=== debian/changelog ===
osmium-tool (1.18.0-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:08:34 +0200

osmium-tool (1.18.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:58:09 +0200

osmium-tool (1.18.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.22.0 for extract*64 tests.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 18 Mar 2025 05:27:24 +0100
